package sale

import (
	"context"
	"git.kumo.work/shama/service/client"
)

type append struct {
}

// List @TITLE 产品列表
func (a *append) List(ctx context.Context, args ArgsProductList) (reply ReplyProductList, err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	err = xClient.Call(ctx, "List", args, &reply)
	return
}

type ArgsAppendAllSearch struct {
	SaleId     int64 // 销售合同id
	WorkflowId int64 // 审核id
}

// All @TITLE 获取产品
func (a *append) All(ctx context.Context, args ArgsAppendAllSearch) (reply []ProductItem, err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	err = xClient.Call(ctx, "All", args, &reply)
	return
}

// Add @TITLE 添加商品
func (a *append) Add(ctx context.Context, args ArgsProductAdd) (err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	reply := 0
	return xClient.Call(ctx, "Add", args, &reply)
}

// Info @TITLE 产品详情
func (a *append) Info(ctx context.Context, saleProductId int64) (reply ReplyProductInfo, err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	err = xClient.Call(ctx, "Info", saleProductId, &reply)
	return
}

// Infos @TITLE 产品详情
func (a *append) Infos(ctx context.Context, saleProductIds []int64) (reply []ReplyProductInfo, err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	err = xClient.Call(ctx, "Infos", saleProductIds, &reply)
	return
}

// Edit @TITLE 编辑产品
func (a *append) Edit(ctx context.Context, args ArgsProductEdit) (err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	reply := 0
	return xClient.Call(ctx, "Edit", args, &reply)
}

// MultiEdit @TITLE 批量编辑
func (a *append) MultiEdit(ctx context.Context, args []MultiData) (err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	reply := 0
	return xClient.Call(ctx, "MultiEdit", args, &reply)
}

// Delete @TITLE 删除产品
func (a *append) Delete(ctx context.Context, saleProductIds []int64) (err error) {
	xClient, err := client.GetClient(a)
	if err != nil {
		return
	}
	reply := 0
	return xClient.Call(ctx, "Delete", saleProductIds, &reply)
}
